# encoding: utf-8
require 'rubygems'
require 'the_scrap'
require 'pp'

#require 'active_record'
#require 'mysql2'
#require 'activerecord-import'

#ActiveRecord::Base.establish_connection( :adapter => "mysql2",  :host => "localhost",
# :database => "test", :username => "root", :password => ""  )
#
##custom update_at,created_at
#ActiveRecord::Base.record_timestamps = false
#
#class Article < ActiveRecord::Base
#  validates :ori_id,:uniqueness => {:scope => :cat_id} 
#end

#create Object
scrap = TheScrap::ListObj.new

#set start url
#放完成的抓取上来不是很合适，所以把网址改了。
scrap.url = "http://www.xxx.com/news/review/"

#fragment css selector
scrap.item_frag = ".center ul li.content"

#scrap attr list
scrap.attr_title = 'h2 a'
scrap.attr_ori_url = ['h2 a','href']
scrap.attr_image = ['.detail a img','src']
scrap.attr_description = '.detail p'
scrap.attr_infos = '.arcilte_info'

#debug
scrap.debug = true
scrap.verbose = true


#html preprocess
scrap.html_proc << lambda { |html|
  #html.gsub(/abcd/,'efgh')
  html
}

#filter scraped item
scrap.item_filters << lambda { |item_info| 
  return false if item_info['title'].nil? || item_info['title'].length == 0
  return true
}

#data process
scrap.data_proc << lambda {|url,i|
  i['title'] = i['title'].strip

  if i['infos'] =~ /日期:(.*?)\S+点击/ 
    i['created_at'] = i['updated_at'] =  Time.parse($~[1].strip) - 8*3600
  end
  i.delete('infos')

  if i['ori_url'] =~ /\d+-\d+-(\d+).html/
    i[:ori_id] =  $~[1].to_i
  end

  i[:cat_id] = @cat_id
  i[:source] = 'xxx.com'

}

#result process
scrap.result_proc << lambda {|url,items|
  #articles = []
  items.each do |item| 
    #articles << Article.new(item)
    pp item
  end
  #Article.import articles
}

########### has many pages ###########
#如果设置了可以根据不同的分页方式抓取多页列表

scrap.has_many_pages = true

#:next_page
scrap.pager_method = :next_page
scrap.next_page_css = ".pagenu .next a"

################# has detail page ################
scrap_detail = TheScrap::DetailObj.new
scrap_detail.attr_content = [".ar_in_cont_3",:inner_html]

#data process
scrap_detail.data_proc << lambda {|url,i|
  content = i['content'].encode('utf-8')

  regex = %q{<a href="http://www\.xxx\.com/" target="_blank"><u>(.*?)</u></a>}
  content.gsub!(/#{regex}/,'\1')

  content.gsub!(/<div class="context">.*/m,'')
  content.gsub!(/style=".*?width:.*?\d+px; height:.*?\d+px;.*?"/,'')

  regex = %q{<a href="http://www.xxx.com/.*?" target="_blank">.*?</a>}
  content.gsub!(/#{regex}/m,'')
  
  i['content'] = content.strip
}


#get url from list attr and extra data by scrap_detail
scrap.detail_info << [scrap_detail,'ori_url']

scrap_detail.encoding = 'gbk'
scrap.encoding = 'gbk'


#scrap
[
  {url:'http://www.xxx.com/news/review/',cat_id:1},
  {url:'http://www.xxx.com/news/yejie/',cat_id:2},
  {url:'http://www.xxx.com/analysis/',cat_id:3},
].each do |item| 

  scrap.url = item[:url]
  puts "start url:#{scrap.url}"
  @cat_id = item[:cat_id]
  scrap.scrap_list

end

